/**---------------------------------------------------------------------------
* Ȩ 2004 ľ
* һȨ
* 
* ·ַʹԴʽͶƸʽǷ޸ģڷ
* ½У
* 1. ·ַԴ뱣ȨϢбԼ
*    
* 2. ·ַĶƸʽٴβȨϢ
*    Լڱַеĵṩķ
*
* ߺͲߡմˡṩκʽʽıֻ֤
* ڵƣκҵԺĿԵʽ
* ֮Ч߻߲ڱɵκֱӵء
* ӵءءءͽԵأɴ˶𺦣
* µĲƵڣƷȡãʹù̡ݡ
* ɴ˲֮ʧҵΪжϣڼʹ֪
* 𺦺跨ʹñĹУκ
* εƲ⣬Ƿںͬ롢޶񡢻ȨΪ
*Ρ
* 
* 
*
* Copyright (c) 2004 The Woodpecker Foundation
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
* 1. Redistributions of source code must retain the above copyright
*    notice, this list of conditions and the following disclaimer.
* 2. Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the
*    documentation and/or other materials provided with the distribution.
*
* THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
* ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
* FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
* OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
* LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
* OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
* SUCH DAMAGE.
**---------------------------------------------------------------------------
*/

#include <stdio.h>
#include <glib.h>
#include <assert.h>
#include "simpleshm.h"

#define MAXROW 10

SSPool *SScreatePool(int size)
{
    SSPool *pool;

    pool = (SSPool *)malloc(sizeof(SSPool));
    pool->ghtContainer = g_hash_table_new(NULL, NULL);
    pool->maxSize = size;
    pool->size = 0;
    pool->list = NULL;

    //TODO :attach to share memory
}

int SSdestroyPool(SSPool *pool)
{
    //TODO: free the malloc object
    g_list_free(pool->list);
    g_hash_table_destroy(pool->ghtContainer);
}

int SSgetSize(SSPool *pool)
{
    return pool->size;
}

int SSpush(SSPool *pool, gpointer key, gpointer value)
{
    assert(pool != NULL);
    g_hash_table_insert(pool->ghtContainer, key, value);

    pool->list = g_list_prepend(pool->list, key);
    pool->size =+ 1;
}

gpointer SSpull(SSPool *pool)
{
    gpointer *ptr;

    assert(pool != NULL);
    if (pool->size <= 0) 
        return NULL;

    ptr = g_list_nth_data(pool->list, 0);
    g_list_delete_link(pool->list, g_list_nth(pool->list, 0));
    pool->size =- 1;

    return ptr;
}

gpointer SSpopup(SSPool *pool)
{
    gpointer ptr;

    assert(pool != NULL);
    if (pool->size <= 0) 
        return NULL;

    ptr = g_list_nth_data(pool->list, pool->size - 1);
    g_list_delete_link(pool->list, g_list_nth(pool->list, pool->size - 1));
    pool->size =- 1;

    return ptr;
}

/** 
 * test suit for:
 *                SSCreatePool
 *                SSDestoryePool
 *                SSgetSize
 *                SSpush
 *                SSpopup
 * 
 */
int testSSPool()
{
    int i;
    char key[10], value[100];
    SSPool *pool;
    
    pool = SScreatePool(0);

    /* push message into pool */
    for (i = 0; i < MAXROW; i ++){
        sprintf(key, "%d", i);
        sprintf(value, "%s", "value%d", i);
        SSpush(pool, (gpointer)key, (gpointer)value);
    }
    printf("now push %d row into pool.\n hash table size is:", i, SSgetSize(pool));

    /* popup message from pool */
    for (i = 0; i < MAXROW; i++){
        strcpy(value, (char *)SSpopup(pool));
        printf("(%s, %s) read\n", key, value);
    }
    printf("now popup %d row from pool.\n hash table size is:", i, SSgetSize(pool));
    
    return ;
}
int testGlib()
{
    int i;
    char s[100], key[10];
    GHashTable *gt;

    gt = g_hash_table_new(NULL, NULL);
    
    for (i = 0; i < MAXROW; i ++){
    	sprintf(s, "long long ago there was a king who love horse very much, hello, Ϳ value%d", i);
        sprintf(key, "%d", i);
    	g_hash_table_insert(gt, (gpointer)key, (gpointer)s);
    }
    printf("%d rows inserted.\n", MAXROW);
    
    for (i = 0; i < MAXROW; i ++){
        sprintf(key, "%d", i);
        strcpy(s, (char *)g_hash_table_lookup(gt, (gpointer)key));
    	printf("read (%s, %s)\n", key, s);
    }
    strcpy(key, "2");
    strcpy(s, (char *)g_hash_table_lookup(gt, (gpointer)(key)));
    printf("example read (%s, %s)\n", key, s);
    printf("%d rows read.\n", MAXROW);

    g_hash_table_destroy(gt);
}

int testshm(char *s)
{
    int fd, shmid, i = 9;
    shmid = shmcreate("/tmp/hello123", 1000);
    printf("shmid=%d\n", shmid);
    if (strcmp(s, "w") == 0)
        shmwrite(shmid, &i, sizeof(int));
    else{
        i = 0;
        shmread(shmid, &i, sizeof(int));
        printf("read i = %d\n", i);
    }

}
int main(int argc, char *args[])
{
    testshm(args[1]);     
//  testGlib();
//  testSSPool();
}
