/**---------------------------------------------------------------------------
* Ȩ 2004 ľ
* һȨ
* 
* ·ַʹԴʽͶƸʽǷ޸ģڷ
* ½У
* 1. ·ַԴ뱣ȨϢбԼ
*    
* 2. ·ַĶƸʽٴβȨϢ
*    Լڱַеĵṩķ
*
* ߺͲߡմˡṩκʽʽıֻ֤
* ڵƣκҵԺĿԵʽ
* ֮Ч߻߲ڱɵκֱӵء
* ӵءءءͽԵأɴ˶𺦣
* µĲƵڣƷȡãʹù̡ݡ
* ɴ˲֮ʧҵΪжϣڼʹ֪
* 𺦺跨ʹñĹУκ
* εƲ⣬Ƿںͬ롢޶񡢻ȨΪ
*Ρ
* 
* 
*
* Copyright (c) 2004 The Woodpecker Foundation
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
* 1. Redistributions of source code must retain the above copyright
*    notice, this list of conditions and the following disclaimer.
* 2. Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the
*    documentation and/or other materials provided with the distribution.
*
* THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
* ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
* FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
* OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
* LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
* OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
* SUCH DAMAGE.
**---------------------------------------------------------------------------
*/

#include "spshm.h"
#define _IN_SPSHM_C_


/* create & attach shared memory if not exist
 * attach shared memory if exist
 */
void *shminit(char *fn, size_t len)
{
    int shmid, oflag, fid;
    void *ptr;
    struct shmid_ds buff;

    oflag = SVSHM_MODE|IPC_CREAT;
    if ( (fid = ftok(fn, 0)) < 0)
        return NULL;
    if  ((shmid = shmget(fid, len, oflag)) < 0)
        return NULL;
    if ( (ptr = shmat(shmid, NULL, 0)) == (unsigned char *) -1)
        return NULL;
    
    /* retset to zero 
    if (shmctl(shmid, IPC_STAT, &buff))
        return NULL;

    memset(ptr, 0, buff.shm_segsz);
*/
    return ptr;
}

int shmrm(char *fn)
{
    int shmid, oflag, fid;

    oflag = SVSHM_MODE|IPC_CREAT;
    if ( (fid = ftok(fn, 0)) < 0)
        return -1;
    if  ((shmid = shmget(fid, 0, oflag)) < 0)
        return -2;
    return shmctl(shmid, IPC_RMID, NULL);
}

/* if exist return shmid
 * if noexist return 0
 * if exception return -1
 */
int shmgetid(char *fn)
{
    int shmid, oflag, fid;

    oflag = SVSHM_MODE;
    if ( (fid = ftok(fn, 0)) < 0)
        return NULL;
    shmid = shmget(fid, 0, oflag);
    if (shmid > 0)
        return shmid;
    else if (ENOENT == errno)
        return 0;
    else
        return -1;
}
    



 
int shmwrite(int id, void *val, size_t len)
{
    struct shmid_ds buff;
    unsigned char *pval = (unsigned char*)val;
    unsigned char *ptr;

    if ( (ptr = shmat(id, NULL, 0)) == (unsigned char *) -1)
        return -1;
    if (shmctl(id, IPC_STAT, &buff))
        return -1;

    memcpy(ptr, pval, buff.shm_segsz);
    shmdt(ptr);
    return 0;
}

int shmread(int id, void *val, size_t len)
{
    struct shmid_ds buff;
    unsigned char *pval = (unsigned char*)val;
    unsigned char *ptr;

    if ( (ptr = shmat(id, NULL, 0)) == (unsigned char *) -1)
        return -1;
    if (shmctl(id, IPC_STAT, &buff))
        return -1;

    memcpy(pval, ptr, buff.shm_segsz);
    shmdt(ptr);
    return 0;
}
